#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <sys/wait.h>

#define STATE_OK 0
#define STATE_CRITICAL 2

static
int check_fail2ban(void)
{
	int status = system("/usr/bin/fail2ban-client ping &>/dev/null");
	return WEXITSTATUS(status);
}

static
void ok(void)
{
	printf("SYSTEM OK - fail2ban is working normally\n");
	exit(STATE_OK);
}

static
void crit(void)
{
	printf("SYSTEM CRITICAL - fail2ban is not working\n");
	exit(STATE_CRITICAL);
}

static
void alarm_handler(int sig)
{
	kill(SIGKILL, 0);
	crit();
}

int main(void)
{
	setresuid(0, 0, 0);

	signal(SIGALRM, alarm_handler);
	alarm(10);

	if (check_fail2ban() == 0)
		ok();
	else
		crit();

	return -1;
}
